diff -Naur hunchentoot-0.14.1_orig/doc/index.html hunchentoot-0.14.1/doc/index.html
--- hunchentoot-0.14.1_orig/doc/index.html	2007-09-25 22:25:23.000000000 -0600
+++ hunchentoot-0.14.1/doc/index.html	2007-09-25 22:36:48.000000000 -0600
@@ -889,6 +889,16 @@
 </blockquote>
 
 <p><br>[Function]
+<br><a class=none name="server-hostname"><b>server-hostname</b> <i><tt>&amp;optional</tt> request</i> =&gt; <i>string</i></a>
+
+<blockquote><br>
+
+Returns just the hostname portion of the incoming <code>Host</code>
+http header (which might otherwise contain a port).
+
+</blockquote>
+
+<p><br>[Function]
 <br><a class=none name="request-method"><b>request-method</b> <i><tt>&amp;optional</tt> request</i> =&gt; <i>keyword</i></a>
 
 <blockquote><br>
diff -Naur hunchentoot-0.14.1_orig/misc.lisp hunchentoot-0.14.1/misc.lisp
--- hunchentoot-0.14.1_orig/misc.lisp	2007-09-25 22:25:23.000000000 -0600
+++ hunchentoot-0.14.1/misc.lisp	2007-09-25 22:31:18.000000000 -0600
@@ -225,7 +225,7 @@
         (t #-:hunchentoot-no-ssl (server-ssl-certificate-file *server*)
            #+:hunchentoot-no-ssl nil)))
 
-(defun redirect (target &key (host (host *request*) host-provided-p)
+(defun redirect (target &key (host (server-hostname *request*) host-provided-p)
                              port
                              (protocol (if (ssl-p) :https :http))
                              (add-session-id (not (or host-provided-p
diff -Naur hunchentoot-0.14.1_orig/packages.lisp hunchentoot-0.14.1/packages.lisp
--- hunchentoot-0.14.1_orig/packages.lisp	2007-09-25 22:25:23.000000000 -0600
+++ hunchentoot-0.14.1/packages.lisp	2007-09-25 22:43:25.000000000 -0600
@@ -202,6 +202,7 @@
            :send-headers
            :server-addr
            :server-address
+	   :server-hostname
            :server-dispatch-table
            :server-local-port
            :server-name
diff -Naur hunchentoot-0.14.1_orig/request.lisp hunchentoot-0.14.1/request.lisp
--- hunchentoot-0.14.1_orig/request.lisp	2007-09-25 22:25:23.000000000 -0600
+++ hunchentoot-0.14.1/request.lisp	2007-09-25 22:43:48.000000000 -0600
@@ -320,6 +320,11 @@
   "Returns the 'Host' incoming http header value."
   (header-in :host request))
 
+(defun server-hostname (&optional (request *request*))
+  "Returns just the hostname (but not the port) of the 'Host' incoming
+http header value."
+  (car (cl-ppcre:split ":" (host request))))
+
 (defun request-uri (&optional (request *request*))
   "Returns the request URI."
   (cond ((server-mod-lisp-p *server*) (header-in :url request))
